#########################
# Objevovani skupin
#########################



##################################################
# Vizualizace výsledků odlišně exprimovaných genů
##################################################

## a) Nejdrive vytvorime heatmapu z top100 odlisne exprimovanych genu mezi ER+ a ER-
  # Vyextrahujeme matici expresnich dat o top100 genech, vsechny vzorky:
  load("top100.rdata")
  load(file="GSE20194_MDACC_Expression.rdata")
  X2=X
  clinical2 <- read.csv("GSE20194_MDACC_Sample_Info.csv")
  
  Y <- X2[,as.character(top100)]
  dim(Y) #278 100
  
  # Zadefinujeme si barvy v heatmape:
  barvy <- colorRampPalette(c("green", "black", "red"))(15)
  
  # vykreslime heatmapu:
  heatmap(Y, col=barvy, RowSideColors=as.character(as.numeric(clinical2$ER_status)),scale="column")
  
  # korelace genů
  install.packages("corrplot")
  library(corrplot)
  corgen<-cor(Y)
  corrplot(corgen, tl.cex = 0.5)
  
## b) Pokud preneseme top100 genu z nasi analyzy do noveho datoveho souboru, dostaneme podobne shlukovani? 
  #(Jinak receno validujeme nase pozorovani)
  #Nacteme dalsi datovy soubor (TransBig) spolu s tabulkou klinickych dat. 
  load(file="TransBIG-expression.rdata")
  ls()
  clinical <- read.csv("TransBIG-Sample_info.csv")
  head(clinical)
  dim(X) #253 1052
  X_top100 <- X[,intersect(colnames(X), top100)]
  X[1:5,1:5]

  barvy <- colorRampPalette(c("green", "black", "red"))(15)

  # VVykreslime druhou heatmapu jen s 9 geny,ktere jsme v druhe matici nasli.
  heatmap(X[,intersect(colnames(X),top100)], col=barvy, RowSideColors=as.character(clinical$ER.pos.1.yes)+1)

  # Porovname s puvodni heatmapou pokud mame jen 9 genu.
  heatmap(X2[,intersect(colnames(X),top100)], col=barvy, RowSideColors=as.character(as.numeric(clinical2$ER_status)))

  
  
  
  
  ##################################################
  # Úplně nové skupiny
  ##################################################
  
 ## PCA vzorků ##
  rownames(X2) <- substring(rownames(X2),1,9)
  pcares<-prcomp(X2) 
  
  
 ## vizualizace výsledků ##
  plot(pcares)
 
  biplot(pcares)

  library(pca3d)
  
  ER<-clinical2$ER_status
  
  pca2d(pcares, group=ER, biplot=T, legend = "bottomright")
  pca2d(pcares, group=clinical2$Race, biplot=T, legend = "bottomright")
  pca2d(pcares, group=clinical2$HER2.Status, biplot=T, legend = "bottomright")
  
  pca3d(pcares, group = ER, biplot = T, legend = "bottomright")
  pca3d(pcares, group = ER, biplot = T, legend = "bottomright", show.ellipses = T, ellipse.ci = 0.5)
  pca3d(pcares, group = ER, biplot = T, legend = "bottomright", show.centroids = T)
 
  pca3d(pcares, group = clinical2$Race, biplot=T,legend = "bottomright")
  pca3d(pcares, group = clinical2$HER2.Status, biplot=T,legend = "bottomright")
  
 ## redukce dimenzionality ##
  
  sdres<-apply(X2,2,sd) #výpočet variability na gen
  plot(sort(sdres))  #zobrazení výsledků
  abline(h=1) 
  
  sel<-which(sdres>1) # selekce genů se standardní odchylkou větší než 1
  length(sel)
  [1] 832
  
  ## hierarchické zhlukování ##
  # výpočet vzdálenosti
  
  eucl.dist<-dist(X2[,sel], method = "euclidean") #euklideovská vzdálenost
  
  hclustres <- hclust(eucl.dist)
  plot(hclustres) #dendrogram
  
  plot(hclustres, hang=-1, cex=0.6) #dendrogram
  
  # řezání dendrogramu na skupiny
  
  skupiny<-cutree(hclustres, k = 2) # na počet skupin
  table(skupiny, ER) # překryv skupin s ER?
  
  
  skupiny2<-cutree(hclustres, h = 80) # na výšku
  table(skupiny2, ER) # překryv skupin s ER?
  
  
  # vzdálenost závislá na korelaci
  corr<-cor(t(X2[,sel]))# calculating correlation
  corrplot(corr)
  
  corr2<-cor(t(X2[1:25,,sel]))# calculating correlation
  corrplot(corr2)
  
  cor.dist<-as.dist(1-corr)
  hclustrescor<-hclust(cor.dist)
  
  plot(hclustres) #dendrogram
  
  library(gplots)
  heatmap.2(X2[,sel], col=barvy, RowSideColors=as.character(skupiny2),scale="column", trace = "none")
  heatmap.2(X2[,sel], col=barvy, RowSideColors=as.character(skupiny),scale="column", trace = "none")
  
  




